/* procedure d'acquisition de memoire dynamique
   pour le compte d'une subroutine */

/* ATTENTION : cette routine C admet un nb variable de parametres et utilise
 varargs(3)
 Cependant pour eviter certains bugs, on s'arrete sur le 1er parametre
 qui est egal a ier (qui est une adresse, ne l'oublions pas)
	--------------------------------------------------
	exec permet maintenant l'interception des erreurs generees par
	ERMESF ou ERMESS, en utilisant setjmp et longjmp, et
	une zone du COMMON /ERROR/ pour ls stockage de l'environnement
	en cas d'appels imbriques, on revient au dernier exec de la pile,
	et on libere la memoire prise
NOTE : les tailles sont donnees en unites sizeof(t_aligned )

*/

#include <stdio.h>
//*** MILTON ***
#include <stdarg.h>
//#include <varargs.h>
#include "../h/error.h"
#include "../h/image.h"
#define MAXPAR 50


extern debug_; 	/* debug */
extern koctet_;	/* taille de memoire dynamique */
extern struct error error_;

extern char *calloc();

/*#define COEF_ALIGN (sizeof(t_aligned)/sizeof(int4)) */
#define COEF_ALIGN 1


//*** MILTON *** (varargs.h to stdarg.h)
/*
exec_(ier,nbfixe,dimfixe,nbvar,pdsvar,proc,va_alist)
Fort_int *nbfixe,dimfixe[],*nbvar,pdsvar[];
int (*proc)();
Fort_int *ier;
va_dcl
*/
void exec_(Fort_int *ier, Fort_int *nbfixe, Fort_int dimfixe[], Fort_int *nbvar, Fort_int pdsvar[], int (*proc)(),...)
{
	int taille,i,npar,p,tfixe,tvar,pvar,npar_total;
	int nbf,nbv;
	t_aligned *core,*core_ptr;	/* pointeur sur des mots !!!!! */
	Fort_int *param;
	Fort_int *pile[MAXPAR];

	int (*save_ret)();
	va_list ap;
	//*** MILTON *** (varargs.h to stdarg.h)
	va_start(ap,proc);
	//va_start(ap);
	taille = koctet_ <= 0 ? 100 : koctet_ ; 
	taille *= (1024  / sizeof(t_aligned)); /* en unites t_aligned */

	*ier = 0; /* remise a zero de ier */

/* on ne tient pas compte du signe du nb de tableaux */
	nbf = ( *nbfixe < 0 ? - *nbfixe - 1 : *nbfixe );
	nbv = ( *nbvar  < 0 ? - *nbvar  - 1 : *nbvar  );

	npar_total = ( nbf == 0 ? 0 : nbf + 1 ) +
		( nbv == 0 ? 0 : nbv + 1 );

	if(debug_)
		fprintf(stderr,"exec: %d param. pour tableaux\n",npar_total);
	if ( npar_total > MAXPAR || npar_total < 0 ) {
	errpar:		fprintf(stderr,"%s exec:trop de parametres (%d)\n",
				xargv[0],npar_total);
		exit(-1);
	}


	/* calcul de la taille des tableaux fixes */

	tfixe = 0;
	for (i=0;i < nbf ;++i) tfixe += ((dimfixe[i] + COEF_ALIGN -1) /  COEF_ALIGN); /* en nb d'unites alignees */
		/* verifications */

	if ( (tvar = taille - tfixe) < 0 ) {
		fprintf(stderr,"%s exec:tableaux fixes trop grands (%d)\n",xargv[0],tfixe * COEF_ALIGN);
		exit(-1);
	}



	/* cumul des poids des tableaux variables
	   et calcul des tailles */

	pvar = 0;
	for (i=0;i < nbv ;++i) pvar += pdsvar[i];
	for (i=0;i < nbv ;++i)	pdsvar[i] = ( tvar * pdsvar[i] * COEF_ALIGN) / pvar;


	/* allocation de la zone complete (taille) */

	
	if ( (core = (t_aligned *) calloc(taille ,sizeof(t_aligned))) == NULL ) {
		fprintf(stderr,"%s allocation de memoire impossible\n",xargv[0]);
		exit(-1);
		}


	core_ptr = core;

	/* mise en pile des parametres */

	p=0;

		/* parametres tableaux fixes */
	if ( nbf != 0 ) {
		pile[p] = (Fort_int *)core;
		for (i=1;i < nbf ; ++i) pile[++p] = (Fort_int *)(core += ((dimfixe[i-1] + COEF_ALIGN -1) / COEF_ALIGN)) ;
		core += ((dimfixe[nbf-1] + COEF_ALIGN -1) / COEF_ALIGN);
		pile[++p] = (Fort_int *)&dimfixe[0]; 
		++p;
		}

		/* parametres tableaux variables */

	if ( nbv != 0 ) {
		pile[p] = (Fort_int *)core;
		for (i=1;i < nbv ; ++i) pile[++p] = (Fort_int *)(core += ((pdsvar[i-1] + COEF_ALIGN -1) / COEF_ALIGN));
		pile[++p] = (Fort_int *)&pdsvar[0];
		++p;
		}


		/* parametres d'appel */

	npar = 0;
	while(param = va_arg(ap,Fort_int *)) {
		if(param == (Fort_int *)ier) break;
		if(npar_total >= MAXPAR) goto errpar;
		pile[p++] = param;
		npar_total++;
		npar++;
	}

	if (debug_) fprintf(stderr,
		"%s exec:appel de proc. avec %d parametres\n",
		xargv[0],npar_total);


if ( debug_ ) {
	param = pile[nbf];
	for (i=0;i<nbf;++i) 
		fprintf(stderr,"%s exec:tableau fixe adresse 0x%lx taille %dK\n",xargv[0],
			pile[i],*(param + i) * sizeof(t_aligned));

	for (i=0;i<nbv;++i){
		int k;
		param = pile [nbv + (k=( nbf == 0 ? 0 : nbf + 1))];
		fprintf(stderr,"%s exec:tableau variable adresse 0x%lx taille %dK\n",xargv[0],
			pile[i+k],*(param + i) * sizeof(t_aligned));
		}
}

	save_ret = error_.retadr;
	error_.retadr = (int (*)())-1;	/* pour retour dans exec */
	if((*ier = setjmp(error_.retenv)) == 0) {
	  (*proc)(pile[0],pile[1],pile[2],pile[3],pile[4],pile[5],pile[6],
	     pile[7],pile[8],pile[9],pile[10],pile[11],pile[12],pile[13],
	     pile[14],pile[15],pile[16],pile[17],pile[18],pile[19],pile[20],
	     pile[21],pile[22],pile[23],pile[24],pile[25],pile[26],pile[27],
	     pile[28],pile[29],pile[30],pile[31],pile[32],pile[33],pile[34],
	     pile[35],pile[36],pile[37],pile[38],pile[39],pile[40],pile[41]);
	}

	error_.retadr = save_ret;
	free(core_ptr); /* au retour de la procedure on restitue
			   la memoire acquise */

}



/*int *istack_(par)

int par;

{
	return(&par);
}
*/
