% scatter matrix

datastdW = [];
datascatterW = zeros(size(data,2));
datadistW = 0;
datadistB = 0;

datadiff = ( data - repmat(cent1,size(data,1),1) );
datascatterT = datadiff'*datadiff;
datastdT = sqrt( sum(datadiff.^2)./(size(data,1)-1));

for class = 1:size(cent,1)
    % normalized difference values
    centdiff = cent - repmat(cent(class,:), size(cent,1), 1);
    centdiff = centdiff ./ repmat(datastdT, size(cent,1), 1);

    % between-class minimum distance (discanding distance 0)
    centdist = sort(sqrt(sum(centdiff.^2,2)));
    datadistB = datadistB + centdist(2);
end    
datadistB = datadistB / size(cent,1);

for class = 1:size(cent,1)
    dataclass = data(find(idx==class),:);
    ndataclass = size(dataclass,1);
    datadiff = (dataclass - repmat(cent(class,:),ndataclass,1));
    
    % within-class scatter
    datascatterW = datascatterW + datadiff'*datadiff;
    
    % normalized difference values
    datadiff = datadiff ./ repmat(datastdT, ndataclass, 1);
    
    % within-class distance
    datadistW = datadistW + sum(sqrt(sum(datadiff.^2,2)));
    
    % within-class stddev
    datastdW = [datastdW; sqrt( sum(datadiff.^2)./(ndataclass-1) )];
end

datadistW = datadistW / size(data,1);


sprintf('mean within-class distance:\n  %f', datadistW)
sprintf('mean minimum between-class distance:\n  %f', datadistB)
sprintf('mean normalized within-class stddev:\n  %f', mean(mean(datastdW)))
sprintf('scatter det ratio:\n  %f', det(datascatterW)/det(datascatterT))
sprintf('WITHIN-CLASS/BETWEEN-CLASS DISTANCE RATIO:\n %f', datadistW/datadistB)
