basename = 'profiles.ndvi';
classes = [13 14];

perc = 0.1;

values = {};
for iclass=1:length(classes)
    filename = sprintf('%s.class%02d.values.txt', basename, classes(iclass));
    
    values = importdata(filename);
    values = sort(values);
    values_valid = find(max(values) > 0);
    
    imin = 1 + round(size(values,1)*perc);
    imax = size(values,1) - imin;
    
    values_min{iclass} = values(imin, values_valid);
    values_max{iclass} = values(imax, values_valid);
    values_diff{iclass} = values_max{iclass} - values_min{iclass};
end


figure;
str_plot = 'plot(';
for iclass=1:length(classes)
    str_plot = [str_plot 'values_min{' num2str(iclass) '}, values_max{' num2str(iclass) '}, ''.'''];
    if (iclass ~= length(classes))
        str_plot = [str_plot ','];
    end
end
str_plot = [str_plot ')'];
eval(str_plot);
xlabel('min');
ylabel('max');
axis([0 1 0 1]);


figure;
str_plot = 'plot(';
for iclass=1:length(classes)
    str_plot = [str_plot 'values_min{' num2str(iclass) '}, values_diff{' num2str(iclass) '}, ''.'''];
    if (iclass ~= length(classes))
        str_plot = [str_plot ','];
    end
end
str_plot = [str_plot ')'];
eval(str_plot);
xlabel('min');
ylabel('max - min');
