/*
  builds an inrimage sequence out of .dat files

  JP Berroir, Oct 2006
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dirent-universal.h"
#include <inrimage/image.h>
#include "inr_io.h"
#include "file_tools.h"
#include "dlr.h"

// compare 2 dates in yymmdd format
int datecmp( const void *A, const void *B )
{
  struct mydate *a,*b ;
  a=(struct mydate*)A;
  b=(struct mydate*)B;

  if ( a->y != b->y ) return a->y - b->y ;
  if ( a->m != b->m ) return a->m - b->m ;
  return a->d - b->d ;
}
// convert DLR encoding to NDVI
void dlr2ndvi(unsigned char * inBuffer, float *ndviBuffer,
	      int npts , float nodata)
{
  int i ;


  for (i=0;i<npts;i++){
    if (inBuffer[i]==255 || inBuffer[i]==0) ndviBuffer[i]=nodata ;
    else ndviBuffer[i]= (float)inBuffer[i] / 317.0 - 0.1 ;
  }


}

