#ifndef __ENVI2INR_H__
#define __ENVI2INR_H__


// Envi data types
enum EnviType {
  Byte              = 1,
  Int               = 2,
  LongInt           = 3,
  Float             = 4,
  Double            = 5,
  Complex           = 6,
  DoubleComplex     = 9,
  UnsignedInt       = 12,
  UnsignedLongInt   = 13,
  LongInt64         = 14,
  UnsignedLongInt64 = 15
};
typedef enum EnviType EnviType;
  

// INR corresponding data types and data sizes
// default type is 'unsigned fixed'
char *InrTypes[] = {
  "unsigned fixed",
  "unsigned fixed", // byte
  "signed fixed",   // int
  "signed fixed",   // long int
  "float",          // float
  "float",          // double
  "unsigned fixed", // complex
  "unsigned fixed",
  "unsigned fixed",
  "unsigned fixed", // double complex
  "unsigned fixed",
  "unsigned fixed",
  "unsigned fixed", // unsigned int
  "unsigned fixed", // unsigned long int
  "signed fixed",   // long int 64
  "unsigned fixed", // unsigned long int 64
};

// default size is 8
int InrSizes[] = {
  8,
  8,   // byte
  16,  // int
  32,  // long int
  32,  // float
  64,  // double
  64,  // complex
  8,
  8,
  128, // double complex
  8,
  8,
  16,  // unsigned int
  32,  // unsigned long int
  64,  // long int 64
  64   // unsigned long int 64
};


// Envi interleave types
enum EnviInterleave {
  BSQ               = 0,
  BIL               = 1,
  BIP               = 2
};
typedef enum EnviInterleave EnviInterleave;
  

#endif




