#ifndef __LINEARALGEBRA_H__
#define __LINEARALGEBRA_H__


#define Epsilon 1.0e-20

typedef struct
              {
              int nbLignes;
              int nbColonnes;
              double* val;
} matrice;


void srand48(long);
double drand48(void);

double ValeurAbs(double a);
double Alea(void);

void free_matrice(matrice **m );

void Copier_Matrice( matrice *dest , matrice *src );
matrice* Initialiser_Matrice(void);
matrice *Rand_Matrice(int);
matrice *Rand_Sym_Matrice(int);
matrice * Rand_Vector( int n );

matrice* Matrice_Nulle(int nbLignes, int nbColonnes);
void Matrice_Identite(matrice* id, int nbLignes, int nbColonnes);

matrice* Transposer_Matrice(matrice* m);
matrice* Multiplier_Matrice(matrice* a, matrice* b);
matrice* Additionner_Matrice(matrice* a, matrice* b);
matrice* Soustraire_Matrice(matrice* a, matrice* b);
matrice* Inverser_Matrice(matrice* m);
matrice* Module_Matrice(matrice* m);
matrice* Calculer_XtX(matrice* a);

double Determinant(matrice *m);
double DeterminantCarre(matrice *m);

void Ajouter_Matrice(matrice* a, matrice* b);
void DecompositionLU(matrice* m, int* index, double *parite);
void TraitementLU(matrice *m, int *index, double *b);
void Multiplication_Scalaire_Matrice(double scalaire, matrice* a);
void Jacobi(matrice* a, int n, double* d, matrice* v, int *nrot);
void Rotate(matrice* a, int i, int j, int k, int l, double g, double h, double s, double tau);
void eigrst(double* d, matrice* v, int n);
void EigenValuesVectors(matrice* a, int n, double* d, matrice* v);

void Afficher_Matrice(matrice* m);
void Printf_Matrice(FILE *f,matrice* m);

#endif
