#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include "str_tools.h"




/*
 *  strListCreate
 * 
 *  
 */
strList *strListCreate(int size)
{
  strList *list;
  if (size <= 0)
    return NULL;
  
  list = (strList *) malloc(sizeof(strList));
  if (!list)
    return NULL;
    
  list->size  = size;
  list->count = 0;
  list->ptr   = (char **)malloc(size*sizeof(char *));
  if (!list->ptr)
  {
    free(list);
    return NULL;
  }
  return list;
}



/*
 *  strListAdd
 * 
 *  
 */
int strListAdd(strList *list, char *str)
{
  if (!str || !list || !list->ptr || list->count >= list->size)
    return -1;
    
  (list->ptr)[list->count] = (char *)malloc(sizeof(char)*(strlen(str)+1));
  strcpy((list->ptr)[list->count], str);
  list->count++;
  
  return list->count;
}



/*
 *  strListFind
 * 
 *  
 */
int strListFind(strList *list, char *str)
{
  int i;
  
  if (!str || !list || !list->ptr)
    return -1;
    
  for (i=0; i<list->count && i<list->size; i++)
    if (!strcmp(str, (list->ptr)[i]))
      return i;
  
  return -1;      
}



/*
 *  strListGet
 * 
 *  
 */
char *strListGet(strList *list, int index)
{
  if (!list || !list->ptr || index >= list->count || index >= list->size)
    return NULL;
    
  return (list->ptr)[index];
}



/*
 *  strListSort
 * 
 *  
 */
int pstrcmp(const char **p1, const char **p2)
{
  return strcmp(*p1, *p2);
}

int strListSort(strList *list)
{
  if (!list || !list->ptr || list->count > list->size)
    return -1;

  qsort(list->ptr, list->count, sizeof(char *), pstrcmp);  
  return 1;
}


/*
 *  strListDestroy
 * 
 *  
 */
int strListDestroy(strList *list)
{
  int i;
  
  if (!list)
    return -1;
    
  if (list->ptr)
    for (i=0; i<list->count && i<list->size; i++)
      free((list->ptr)[i]);
  
  free(list);
  return 1;
}


