#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <inrimage/image.h>
#include "inr_io.h"


#define FNAMESIZE  1024
#define MIN(x,y) ((x<y)?x:y)
#define MAX(x,y) ((x>y)?x:y)



static char Ucmd[] = "-ifile text_file -ofile inr_file\n";

static char Udetail[] =
"Converts a text file containing a matrix of numbers into an INRIMAGE 2D image.\n\
\nInput:\n\
\t-ifile\tFile name of the input text file\n\
\nOutput:\n\
\t-ofile\tFile name of the output INRIMAGE file\n";





int main (int argc, char **argv)
{
  char fnameInput[FNAMESIZE];
  char fnameOutput[FNAMESIZE];

  FILE *fpInput;

  unsigned char *dataInput;
  unsigned char *dataOutput;

  int size_x, size_y, size_z;
  int size_line;
  int ret;
  double value;
  

  /* lecture options */
  inr_init (argc, argv, "1.0", Ucmd, Udetail);
  if (!igetopt1 ("-ifile", "%s", fnameInput))
    iusage_ (Ucmd, Udetail);
  if (!igetopt1 ("-ofile", "%s", fnameOutput))
    iusage_ (Ucmd, Udetail);
  if (tstopts ())                /* s'il reste des options : exit avec message */
    iusage_ (Ucmd, Udetail);


  // opens input data file
  fpInput = fopen(fnameInput, "rt");
  if (!fpInput)
  {
    fprintf(stderr, "Error: could not read input file '%s'.\n", fnameInput);
    return 0;
  }

  size_line = 0;
  while(1)
  {
    ret = fgetc(fpInput);
    if (ret == EOF)
    {
      fprintf(stderr, "Error: could not find valid data in input file '%s'.\n", fnameInput);
      return 0;
    }
    size_line++;
    if (ret == '\n')
      break;
  }
   
  printf("%d\n", size_line);

/*
  // reads header information for all input data and checks if they are appropriate
  if (!inrReadHeader(fnameInput, &size_x, &size_y, &size_z, &type))
  {
    fprintf(stderr, "Error: could not read header information for input file '%s'.\n", fnameInput);
    return 0;
  }
 
  // reads the input classification image
  dataInput = inrReadDataSequence(fnameInput, &size_x, &size_y, &size_z, &type);
  if (!dataInput)
  {
    fprintf (stderr, "Error: could not read input file '%s'.\n", fnameInput);
    fclose(fpTrans);
    return 0;
  }
  typesize = InrTypeSizes[type]/8;
  
  // allocates memory for output data
  dataOutput = (unsigned char *)malloc(size_x*size_y*size_z * typesize * sizeof(unsigned char));
  memcpy(dataOutput, dataInput, size_x*size_y*size_z * typesize);
    
  

  // processes the data
  while (!feof(fpTrans))
  {
    int nitems = fscanf(fpTrans, "%lf %lf", &input_value, &output_value);
    if (nitems != 2)
      continue;

    for (i=0; i<size_x*size_y*size_z; i++)
    {
      value = inrGetDataValue(dataInput, type, i);
      if (value == input_value)
        inrPutDataValue(dataOutput, type, i, output_value);
    }
  }
  fclose(fpTrans);

  
  // writes output translated classification
  if (!inrWriteDataSequence(fnameOutput, size_x, size_y, size_z, dataOutput, type))
  {
    fprintf (stderr, "Error: could not write to output file '%s'.\n", fnameOutput);
    free(dataInput);
    free(dataOutput);
    return 0;
  }
  free(dataInput);
  free(dataOutput);
  
  // copies georreference info if present
  if (inrReadGeoref(fnameInput, &georef))
    inrWriteGeoref(fnameOutput, georef);
  
  fprintf(stderr, "Image successfully translated.\n");
  */
  return 1;
}
