#include <stdio.h>
#include <string.h>
#include "file_tools.h"
#include "modis.h"



/*
 *  modisParseName
 * 
 *  Parses a given MODIS file name
 */
int modisParseName(char *name, ModisInfo *info)
{
  int  infoPresent = 0;
  char satellite;

  if (!name || !info)
    return 0;

  // parses MODIS name
  infoPresent = sscanf(name, "%[^.].%c%4d%3d", info->product, &satellite,
                       &(info->year), &(info->day));
                       
  if (infoPresent != 4)
    return 0;
    
  // converts satellite character to ModisSatellite enum type
  if (satellite == 'A')
    info->satellite = ModisTerra;
  else if (satellite == 'B')
    info->satellite = ModisAqua;
  else
    return 0;

  return 1;
}



/*
 *  modisGetBasename
 *
 *  
 */
char *modisGetBaseName(char *filename, char *basename)
{
  char *ptr;
  strcpy(basename, filename);
  
  ptr = strchr(basename, '.');
  if (!ptr)
    return NULL;
  
  ptr = strchr(ptr+1, '.');
  if (!ptr)
    return NULL;
    
  ptr[0] = '\0';
  return basename;
}


