#ifndef __MODIS_STD_H__
#define __MODIS_STD_H__


/*
 * Definition of MODIS STD states
 */
enum ModisStdState {
    StateUndefined = 0,
    StateAgriculture1,
    StateAgriculture2,
    StateAgriculture3,
    StateSavannah,
    StatePasture,
    StateDeforestation,
    StateDirtyPasture,
    StateRegenSavannah1,
    StateRegenSavannah2,
    StateRegenSavannah3,
    StateUrban,
    MODIS_STD_NUM_STATES
};
typedef enum ModisStdState ModisStdState;


/*
 * Definition of MODIS STD class profiles
 */
enum ModisStdProfile {
    ProfAgriculture1 = 0,
    ProfAgriculture2,
    ProfAgriculture3,
    ProfSavannah,
    ProfPasture,
    ProfDeforestation,
    MODIS_STD_NUM_PROFILES
};
typedef enum ModisStdProfile ModisStdProfile;



/*
 * Definition of MODIS STD methods
 */
stdDiagram *modisStdCreate();


#endif

