#ifndef _NOAA_DATES_H
#define _NOAA_DATES_H

/*
  donne les dates d'une sequence a partir d'un fichier de liste de dates
  au format yyddd

  JP Berroir, Oct 2002
*/

/* tes annee bissextile */
# define isleap(year) \
  ((year) % 4 == 0 && ((year) % 100 != 0 || (year) % 400 == 0))
/* initialise various variables */
//*** MILTON ***
//void init_date();
int init_date(char *datefile);
/* clean those variables */
void clean_date();
/* print on stdout the date for a given frame in julian and usual format */
void print_frame_date( int frame ) ;
/* gives the difference in days between two frames */
int day_difference( int frame1, int frame2 ) ;
/* gives the number of days elapsed from sequence beginning to
   a specified frame */
int day_since_beginning( int frame ) ;
/* gives the number of days elapsed since previous frame */
int day_before( int frame ) ;
/* gives the number of days until next frame */
int day_after( int frame ) ;
/* get the date for a given frame */
int get_julian_day( int frame ) ;
int get_month( int frame ) ;
int get_year( int frame ) ;

/*
  static functions, not to be called 
*/
static char * julien2date( char *in  );
static char * frame_date( int frame ) ;
#endif
