#include <stdio.h>
#include <math.h>
#include "cfsqpusr.h"
#include "sequence_proportions_estimation.h"

#define NR_END 1
#define FREE_ARG char*
#define TOL 0.0001
#define ntirmax 100
//static float sqrarg;
#define SQR(a) ((sqrarg=(a)) == 0.0 ? 0.0 : sqrarg*sqrarg)
#define SIGN(a,b) ((b) >= 0.0 ? fabs(a) : -fabs(a))
//static float maxarg1, maxarg2;
#define FMAX(a,b) (maxarg1=(a),maxarg2=(b),(maxarg1) > (maxarg2) ?\
        (maxarg1) : (maxarg2))
//static int iminarg1, iminarg2;
#define IMIN(a,b) (iminarg1=(a),iminarg2=(b),(iminarg1) < (iminarg2) ?\
        (iminarg1) : (iminarg2))


void
fonc_obj (nparam, j, X, fj, cdon)
     int nparam, j;
     double *X, *fj;
     dataPropEstim *cdon;

{
  int i, t;
  double som;
  int class;

  *fj = 0.0;
  for (t = 0; t < cdon->nDates; t++)
  {
    som = 0.0;
    for (i = 0; i < nparam; i++)
    {
      class = cdon->local_class[i];
      som += X[i] * (double) cdon->ref_class[t + 1][class];
    }

    *fj += (som - (double) cdon->ref_pixel[t + 1]) *
           (som - (double) cdon->ref_pixel[t + 1]);
  }
  return;
}

/*************************************************************************/

void
fonc_grad (nparam, j, X, gradfj, dummy, cdon)
     int nparam, j;
     double *X, *gradfj;
     dataPropEstim *cdon;
     void (*dummy) ();
{
  int i, k, t;
  double som;
  int class;

  for (i = 0; i < nparam; i++)
  {
    gradfj[i] = 0.0;
    for (t = 0; t < cdon->nDates; t++)
    {
      som = 0.0;

      for (k = 0; k < nparam; k++)
      {
        class = cdon->local_class[k];
        som += X[k] * (double) cdon->ref_class[t + 1][class];
      }
              
      class = cdon->local_class[i];
      gradfj[i] += 2 * (som - (double) cdon->ref_pixel[t + 1]) *
                  (double) cdon->ref_class[t + 1][class];
    }
  }
  return;
}

/*************************************************************************/

void
fonc_cntr (nparam, j, X, gj, cdon)
     int nparam, j;
     double *X, *gj;
     dataPropEstim *cdon;
{
  int i;

  //*** MILTON ***
  *gj = 1;
  for (i = 0; i < nparam; i++)
    *gj -= X[i];
  /*
  switch (j)
  {
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    *** MILTON ***
    case 6:
      *gj = X[j - 1] - 1.0;
      break;
    case 7:
      *gj = 1;
      for (i = 0; i < nparam; i++)
        *gj -= X[i];
      break;
    case 8:
      printf("Ooops!! Case 8 in 'fonc_cntr'!!\n");
      getchar();
      exit(-1);
  }
  return;
  */
}

/*************************************************************************/
void
fonc_grcn (nparam, j, X, gradgj, dummy, cdon)
     int nparam, j;
     double *X, *gradgj;
     void (*dummy) ();
     dataPropEstim *cdon;
{
  int i;
  for (i = 0; i < nparam; i++)
    gradgj[i] = -1.0;
  //*** MILTON ***
  /*
  switch (j)
  {
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    *** MILTON ***
    case 6:
      for (i = 0; i < nparam; i++)
      {
        if (i == j - 1)
          gradgj[i] = 1.0;
        else
          gradgj[i] = 0.0;
      }
      break;
    case 7:
      for (i = 0; i < nparam; i++)
        gradgj[i] = -1.0;
      break;
    case 8:
      printf("Ooops!! Case 8 in 'fonc_grcn'!!\n");
      getchar();
      exit(-1);
  }

  return;
  */
}

/*************************************************************************/
void
estim_prop_pix (X, nparam, cdon)
     double *X;
     int nparam;
     dataPropEstim *cdon;

{
  int nf, nineq, neq, mode, iprint, miter, neqn, nineqn,
      ncsrl, ncsrn, nfsr, mesh_pts[1], inform;
  double bigbnd, eps, epsneq, udelta;
  double *bl, *bu, *f, *g, *lambda;
  int i;
  //void *cd;

  mode = 100;
  //*** MILTON ***
  iprint = 0;
  //iprint = 0;
  miter = 500;
  bigbnd = 1.e10;
  eps = 1.0e-8;
  epsneq = 0.e0;
  udelta = 0.e0;
  nf = 1;
  nfsr = 0;
  neqn = 0;
  nineqn = 0;
  //*** MILTON ***
  nineq = 0;
  //nineq = nparam;
  neq = 1;
  mesh_pts[0] = 0;
  ncsrl = ncsrn = 0;

  bl = (double *) calloc (nparam, sizeof (double));
  bu = (double *) calloc (nparam, sizeof (double));
  f = (double *) calloc (nf + 1, sizeof (double));
  g = (double *) calloc (nineq + neq + 1, sizeof (double));
  lambda = (double *) calloc (nineq + neq + nf + nparam, sizeof (double));
  for (i = 0; i < nparam; i++)
  {
    bl[i] = 0.0;
    bu[i] = 1.0;
    //*** MILTON ***
    X[i] = 1.0/nparam;
    //X[i] = 16.71;
  }


  cfsqp (nparam, nf, nfsr, nineqn, nineq, neqn, neq, ncsrl, ncsrn, mesh_pts,
         mode, iprint, miter, &inform, bigbnd, eps, epsneq, udelta, bl, bu, X,
         f, g, lambda, fonc_obj, fonc_cntr, fonc_grad, fonc_grcn, cdon);

  //*** MILTON *** TEMP!
  /*
  if (inform != 0)
    printf("Ooops!! Didn't find solution!\n");
  */
  
  free (bl);
  free (bu);
  free (f);
  free (g);
  free (lambda);
}

/*************************************************************************/


float *
vector (long nl, long nh)
/* allocation d'un vecteur de reels v[nl..nh] */
{
  float *v;

  v = (float *) malloc ((size_t) ((nh - nl + 1 + NR_END) * sizeof (float)));
  if (!v)
  {
    printf ("probleme d'allocation de memoire\n");
    exit (1);
  }
  return v - nl + NR_END;
}

float **
matrix (long nrl, long nrh, long ncl, long nch)
/* allocation d'une matrice de reels m=[nrl..nrh][ncl..nch] */
{
  long i, nrow = nrh - nrl + 1, ncol = nch - ncl + 1;
  float **m;

  /* allocation des pointeurs sur les lignes */
  m = (float **) malloc ((size_t) ((nrow + NR_END) * sizeof (float *)));
  if (!m)
  {
    printf ("probleme d'allocation de memoire\n");
    exit (1);
  }
  m += NR_END;
  m -= nrl;

  /* allocation des lignes et leurs  pointeurs */
  m[nrl] = (float *) malloc ((size_t) ((nrow * ncol + NR_END) * sizeof (float)));
  if (!m[nrl])
  {
    printf ("probleme d'allocation de memoire\n");
    exit (1);
  }
  m[nrl] += NR_END;
  m[nrl] -= ncl;

  for (i = nrl + 1; i <= nrh; i++)
    m[i] = m[i - 1] + ncol;

  /* return pointer to array of pointers to rows */
  return m;
}

void
free_vector (v, nl, nh)
     float *v;
     long nh, nl;
/* liberer le vecteur de float cree par vector() */
{
  free ((FREE_ARG) (v + nl - NR_END));
}

void
free_matrix (m, nrl, nrh, ncl, nch)
     float **m;
     long nch, ncl, nrh, nrl;
/* libere la matrice de float cree par matrix() */
{
  free ((FREE_ARG) (m[nrl] + ncl - NR_END));
  free ((FREE_ARG) (m + nrl - NR_END));
}


void propEstimReset(dataPropEstim *propEstim, int resetRefClass)
{
  int iClass, iDate;
  
  if (resetRefClass)
  {
    for (iDate=0; iDate<propEstim->nDates; iDate++)
      for (iClass=-1; iClass<propEstim->nClass; iClass++)
        propEstim->ref_class[iDate + 1][iClass + 1] = 0;
  }

  for (iDate=-1; iDate<propEstim->nDates; iDate++)
    propEstim->ref_pixel[iDate + 1] = 0;
  
  for (iClass=-1; iClass<propEstim->nClass; iClass++)
    propEstim->prior_prob[iClass + 1] = 0;

  for (iClass=0; iClass<propEstim->nClass; iClass++)
    propEstim->local_class[iClass] = 0;
    
  propEstim->nClassLocal = 0;
}
